#ifndef HARKIO_HARKCONFIG_HARKCONFIGFILEXMLREADER_HPP_
#define HARKIO_HARKCONFIG_HARKCONFIGFILEXMLREADER_HPP_

#include <boost/shared_ptr.hpp>
#include <glibmm/ustring.h>
#include <harkio2/AnalyzeError.hpp>
#include <harkio2/harkconfig/HarkConfigFileReader.hpp>

/** @file HarkConfigFileXMLReader.hpp
 * @brief HarkConfigFileXMLReader クラスの定義
 */

namespace harkio2
{
namespace harkconfig
{

class HarkConfigFile;

/** @brief XML形式のHARK-configファイルに対応した HarkConfigFileReader の実装。
 */
class HarkConfigFileXMLReader :
    public HarkConfigFileReader
{
public:
    /** @brief XMLリーダーを構築する。
     * @param uri 読み込みたいXMLファイルのURI
     */
    HarkConfigFileXMLReader(const Glib::ustring& uri);

    /** @brief HarkConfigFile データ構造をコンストラクタで指定されたXMLファイルから読み込み、返す。
     * @return 読み込んだデータ
     */
    virtual boost::shared_ptr<HarkConfigFile> Read() throw (harkio2::AnalyzeError);

private:
    Glib::ustring uri;
};

}
}

#endif // HARKIO_HARKCONFIG_HARKCONFIGFILEXMLREADER_HPP_

