#include <harkio2/Version.hpp>
#include <sstream>

/** @file Version.cpp
 * @brief Version class definition.
 */

using namespace std;

namespace harkio2
{

Version::Version(unsigned int major_, unsigned int minor_)
    : major_(major_), minor_(minor_)
{
}

bool Version::operator ==(const Version& rhs) const
{
    return this->major_ == rhs.major_ && this->minor_ == rhs.minor_;
}

bool Version::operator <(const Version& rhs) const
{
    return (this->major_ < rhs.major_) ||
        (this->major_ == rhs.major_ && this->minor_ < rhs.minor_);
}

std::string Version::ToString() const
{
    stringstream ss;
    ss << major_ << '.' << minor_;
    return ss.str();
}

}

