#define BOOST_TEST_MODULE "testcase for HarkFileBinaryReader class"
#define BOOST_TEST_DYN_LINK
#include "common.hpp"

#include <boost/test/unit_test.hpp>

#include <fstream>
#include <harkio2/hark/DataSet.hpp>
#include <harkio2/hark/HarkFile.hpp>
#include <harkio2/hark/HarkFileReader.hpp>
#include <harkio2/hark/HarkFileBinaryReader.hpp>
#include <harkio2/hark/hgtf/Fmt.hpp>

BOOST_AUTO_TEST_CASE(read_test)
{
    std::ifstream harkFileData("sample_hgtf_m2pg", std::ios::in | std::ios::binary);

    BOOST_REQUIRE(harkFileData);

    boost::shared_ptr<harkio2::hark::HarkFileReader> reader(
            new harkio2::hark::HarkFileBinaryReader(harkFileData));

    boost::shared_ptr<harkio2::hark::HarkFile> hark = reader->Read();

    boost::shared_ptr<harkio2::hark::DataSet> fmt = hark->GetDataSet("hgtf::Fmt");
    boost::shared_ptr<harkio2::hark::hgtf::Fmt1_0> fmt10 = boost::dynamic_pointer_cast<harkio2::hark::hgtf::Fmt1_0>(fmt);

    BOOST_REQUIRE(fmt10);
}

